%Lotka-Volterra modell

global a x0 y0
%paraméterek
a=1.0;
%kezdeti értékek
x0 = 0;
y0 = 0.1;

%differenciálegyenlet
function dy=odefun(y,t)
global a
dy=y;
dy(1) = y(2)-y(1)*y(1)*y(1)+a*y(1);
dy(2) = -y(1);
endfunction

%megoldás
T = [0:0.1:20]';
Y = lsode(@odefun,[x0,y0],T);

%ábrázolás
%%for i=101:201
i=50;
%t(x)
subplot(2,2,3)
plot(Y(:,1),T,'-b',"linewidth",3,
Y(i,1),T(i),'o',"markeredgecolor","red","markerfacecolor","red","markersize",12);
set(gcf(), "units","points", "position",[0 0 640 640]);
axis([-2, 2, 0, 20], "ij", "labelxy");
set(gca(), "linewidth",2, "fontsize",20, "xaxislocation", "top");
set(gca(), "position",[0.08 0.03 0.41 0.41], "ticklength",[0.02 0.025]);
%xlabel('x');
ylabel('t');
line([Y(i,1) Y(i,1)], [T(i) 0], "linestyle", "--", "color", "k", "linewidth", 1);
%y(t)
subplot(2,2,2) 
plot(T,Y(:,2),'-b',"linewidth",3,
T(i),Y(i,2),'o',"markeredgecolor","red","markerfacecolor","red","markersize",12);
axis([0, 20, -2, 2], "labelxy");
set(gca(), "linewidth",2, "fontsize",20);
set(gca(), "position",[0.57 0.57 0.41 0.41], "ticklength",[0.02 0.025]);
xlabel('t');
ylabel('y');
line([0 T(i)], [Y(i,2) Y(i,2)], "linestyle", "--", "color", "k", "linewidth", 1);
%fázistér
subplot(2,2,1)
%%plot(Y(1:i,1),Y(1:i,2),'-r',"linewidth",4,
plot(Y(:,1),Y(:,2),'-r',"linewidth",4,
Y(i,1),Y(i,2),'o',"markeredgecolor","red","markerfacecolor","red","markersize",12);
axis([-2, 2, -2, 2], "labelxy");
set(gca(), "linewidth",3, "fontsize",20);
set(gca(), "position",[0.08 0.57 0.41 0.41], "ticklength",[0.02 0.025]);
xlabel('x');
ylabel('y');
line([Y(i,1) 3.5], [Y(i,2) Y(i,2)], "linestyle", "--", "color", "k", "linewidth", 1);
line([Y(i,1) Y(i,1)], [-2.1 Y(i,2)], "linestyle", "--", "color", "k", "linewidth", 1);
filename=sprintf("vanderPol%03d.png",i);
print(filename,"-S640,640");
%%endfor